<?php /**
 * @file
 * Contains \Drupal\ms_coupons\EventSubscriber\InitSubscriber.
 */

namespace Drupal\ms_coupons\EventSubscriber;

use Symfony\Component\HttpKernel\KernelEvents;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

class InitSubscriber implements EventSubscriberInterface {

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() {
    return [KernelEvents::REQUEST => ['onEvent', 0]];
  }

  public function onEvent() {
    // Add a coupon to the cart if set in url.
    if (!empty($_GET['coupon'])) {
      $coupon = ms_coupons_load($_GET['coupon']);
      if ($coupon) {
        ms_coupons_add_coupon_to_cart($coupon);
      }
    }
  }

}
