<?php

/**
 * @file
 * Contains \Drupal\ms_coupons\Form\MsCouponsAdmin.
 */

namespace Drupal\ms_coupons\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Render\Element;

class MsCouponsAdmin extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'ms_coupons_admin';
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $config = $this->config('ms_coupons.settings');

    foreach (Element::children($form) as $variable) {
      $config->set($variable, $form_state->getValue($form[$variable]['#parents']));
    }
    $config->save();

    if (method_exists($this, '_submitForm')) {
      $this->_submitForm($form, $form_state);
    }

    parent::submitForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return ['ms_coupons.settings'];
  }

  public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state) {
    $form['main'] = [
      '#type' => 'fieldset',
      '#title' => t('Main Settings'),
      '#collapsible' => FALSE,
      '#collapsed' => FALSE,
    ];
    $form['main']['ms_coupons_enforce_single_coupon_per_cart'] = [
      '#type' => 'checkbox',
      '#title' => t('Force one coupon max per cart?'),
      '#default_value' => \Drupal::config('ms_coupons.settings')->get('ms_coupons_enforce_single_coupon_per_cart'),
      '#description' => t("If this is checked, only one coupon will be allowed per
      cart, with the latest one overriding older ones."),
    ];

    return parent::buildForm($form, $form_state);
  }

}
