<?php

/**
 * @file
 * Contains \Drupal\ms_coupons\Form\MsCouponsDeleteConfirm.
 */

namespace Drupal\ms_coupons\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Render\Element;

class MsCouponsDeleteConfirm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'ms_coupons_delete_confirm';
  }

  public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state, $cid = NULL) {
    $coupon = ms_coupons_load($cid);
    $form['#ms_coupons_cid'] = $coupon->cid;
    return confirm_form($form, t('Are you sure you want to delete coupon %name with code %code?', [
      '%name' => $coupon->name,
      '%code' => $coupon->code,
    ]), 'admin/moneysuite/ms_coupons', t('This action cannot be undone. Deleting this coupon will remove all records of past uses as well.'), t('Delete'));
  }

  public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {
    $coupon = ms_coupons_load($form['#ms_coupons_cid']);

    db_delete('ms_coupons')
      ->condition('cid', $form['#ms_coupons_cid'])
      ->execute();

    drupal_set_message(t('Coupon %name has been deleted.', [
      '%name' => $coupon->name
      ]));
    $form_state->set(['redirect'], 'admin/moneysuite/ms_coupons' . ($coupon->status ? '' : '/inactive'));
  }

}
