<?php /**
 * @file
 * Contains \Drupal\ms_discounts\Controller\DefaultController.
 */

namespace Drupal\ms_discounts\Controller;

use Drupal\Core\Controller\ControllerBase;

/**
 * Default controller for the ms_discounts module.
 */
class DefaultController extends ControllerBase {

  public function ms_discounts_display() {
    $header[] = [
      'data' => t('Name'),
      'field' => 'name',
    ];
    $header[] = [
      'data' => t('Status'),
      'field' => 'status',
      'sort' => 'asc',
    ];
    $header[] = [
      'data' => t('Value'),
      'field' => 'value',
    ];
    $header[] = [
      'data' => t('Scope'),
      'field' => 'scope',
    ];
    $header[] = [
      'data' => t('Valid until'),
      'field' => 'valid_until',
    ];
    $header[] = [
      'data' => t('Usage'),
      'field' => 'used',
    ];
    $header[] = ['data' => t('Actions')];

    $query = db_select('ms_discounts', 'd');
    $query->fields('d');

    $query = $query->extend('TableSort')->orderByHeader($header);
    $query = $query->extend('PagerDefault')->limit(20);
    $result = $query->execute();

    $rows = [];
    foreach ($result as $row) {
      // @FIXME
// l() expects a Url object, created from a route name or external URI.
// $actions = l(t('edit'), "admin/moneysuite/ms_discounts/edit/" . $row->id);

      // @FIXME
// l() expects a Url object, created from a route name or external URI.
// $actions .= ' ' . l(t('delete'), "admin/moneysuite/ms_discounts/delete/" . $row->id);


      $rows[] = [
        $row->name,
        $row->status,
        ms_discounts_get_discount_string($row),
        ms_core_get_scope_name($row->scope),
        format_date($row->valid_until, 'small'),
        $row->used,
        $actions,
      ];
    }

    if (count($rows)) {
      // @FIXME
// theme() has been renamed to _theme() and should NEVER be called directly.
// Calling _theme() directly can alter the expected output and potentially
// introduce security issues (see https://www.drupal.org/node/2195739). You
// should use renderable arrays instead.
// 
// 
// @see https://www.drupal.org/node/2195739
// $output = theme('table', array('header' => $header, 'rows' => $rows, 'attributes' => array('width' => '100%'), 'empty' => t('No discounts.')));

      // @FIXME
// theme() has been renamed to _theme() and should NEVER be called directly.
// Calling _theme() directly can alter the expected output and potentially
// introduce security issues (see https://www.drupal.org/node/2195739). You
// should use renderable arrays instead.
// 
// 
// @see https://www.drupal.org/node/2195739
// $output .= theme('pager', array('tags' => NULL));

    }
    else {
      $output = '<p>' . t('There are currently no discounts in the system.') . '</p>';
    }

    return $output;
  }

}
