<?php

/**
 * @file
 * Contains \Drupal\ms_discounts\Form\MsDiscountsDeleteConfirm.
 */

namespace Drupal\ms_discounts\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Render\Element;

class MsDiscountsDeleteConfirm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'ms_discounts_delete_confirm';
  }

  public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state, $id = NULL) {
    $discount = ms_discounts_load($id);
    $form['#ms_discounts_id'] = $discount->id;
    return confirm_form($form, t('Are you sure you want to delete the discount %name?', [
      '%name' => $discount->name
      ]), 'admin/moneysuite/ms_discounts', t('This action cannot be undone. Deleting this discount will remove all records of past uses as well.'), t('Delete'));
  }

  public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {
    $discount = ms_discounts_load($form['#ms_discounts_id']);

    db_delete('ms_discounts')
      ->condition('id', $form['#ms_discounts_id'])
      ->execute();

    drupal_set_message(t('Discount %name has been deleted.', [
      '%name' => $discount->name
      ]));
    $form_state->set(['redirect'], 'admin/moneysuite/ms_discounts');
  }

}
