<?php

/**
 * @file
 * Contains \Drupal\ms_role_discounts\Form\MsRoleDiscountsAdmin.
 */

namespace Drupal\ms_role_discounts\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Render\Element;

class MsRoleDiscountsAdmin extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'ms_role_discounts_admin';
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $config = $this->config('ms_role_discounts.settings');

    foreach (Element::children($form) as $variable) {
      $config->set($variable, $form_state->getValue($form[$variable]['#parents']));
    }
    $config->save();

    if (method_exists($this, '_submitForm')) {
      $this->_submitForm($form, $form_state);
    }

    parent::submitForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return ['ms_role_discounts.settings'];
  }

  public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state) {
    $form['main'] = [
      '#type' => 'fieldset',
      '#title' => t('Main Settings'),
      '#collapsible' => FALSE,
      '#collapsed' => FALSE,
      '#ms_override' => TRUE,
    ];
    $form['main']['ms_role_discounts_scope'] = [
      '#type' => 'radios',
      '#title' => t('Scope'),
      '#default_value' => \Drupal::config('ms_role_discounts.settings')->get('ms_role_discounts_scope'),
      '#options' => ms_core_get_scopes(),
      '#required' => TRUE,
      '#ms_override' => TRUE,
      '#description' => t('Whether the discount should affect the first payment only or all payments. Only applies for Recurring Payments.'),
    ];

    $roles = user_roles();
    foreach ($roles as $rid => $name) {
      // @FIXME
// // @FIXME
// // The correct configuration object could not be determined. You'll need to
// // rewrite this call manually.
// $form['role_discounts_' . $rid] = array(
//       '#type' => 'fieldset',
//       '#title' => t('Discounts/Fees for @name', array('@name' => $name)),
//       '#collapsible' => TRUE,
//       '#ms_override' => TRUE,
//       '#collapsed' => variable_get('ms_role_discounts_amount_' . $rid, 0) == 0 ? TRUE : FALSE,
//     );


      // @FIXME
// // @FIXME
// // The correct configuration object could not be determined. You'll need to
// // rewrite this call manually.
// $form['role_discounts_' . $rid]['ms_role_discounts_name_' . $rid] = array(
//       '#type' => 'textfield',
//       '#title' => t('Display Label for Discount/Fee in Cart and Order'),
//       '#size' => 32,
//       '#maxlength' => 64,
//       '#default_value' => variable_get('ms_role_discounts_name_' . $rid, t('Role Discount')),
//       '#description' => t("This is what will appear next to the Discount/Fee amount on orders."),
//       '#required' => TRUE,
//       '#ms_override' => TRUE,
//     );

      // @FIXME
// // @FIXME
// // The correct configuration object could not be determined. You'll need to
// // rewrite this call manually.
// $form['role_discounts_' . $rid]['ms_role_discounts_amount_' . $rid] = array(
//       '#type' => 'textfield',
//       '#title' => t('Discount/Fee Amount to apply to orders by default'),
//       '#size' => 32,
//       '#maxlength' => 64,
//       '#default_value' => variable_get('ms_role_discounts_amount_' . $rid, 0),
//       '#description' => t("This discount/fee will apply to all orders by default. Use a negative value to give a discount, and a positive value to give a fee."),
//       '#required' => TRUE,
//       '#ms_override' => TRUE,
//     );

      // @FIXME
// // @FIXME
// // The correct configuration object could not be determined. You'll need to
// // rewrite this call manually.
// $form['role_discounts_' . $rid]['ms_role_discounts_type_' . $rid] = array(
//       '#type' => 'radios',
//       '#title' => t('Percentage or Fixed Amount?'),
//       '#default_value' => variable_get('ms_role_discounts_type_' . $rid, 'percentage'),
//       '#options' => array(
//         'percentage' => t('Percentage'),
//         'fixed' => t('Fixed'),
//       ),
//       '#required' => TRUE,
//       '#ms_override' => TRUE,
//     );

    }

    return parent::buildForm($form, $form_state);
  }

}
