<?php

/**
 * @file
 * Contains \Drupal\ms_events\Form\MsEventsDeleteTicketConfirm.
 */

namespace Drupal\ms_events\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Render\Element;

class MsEventsDeleteTicketConfirm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'ms_events_delete_ticket_confirm';
  }

  public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state, $id = NULL) {
    $record = ms_events_get_ticket_by_id($id);
    if ($record->id) {
      $form['#ms_id'] = $record->id;
      return confirm_form($form, t('Are you sure you want to delete this Ticket?'), 'admin/ms_events_tickets', t('This action cannot be undone.'), t('Delete'));
    }
    else {
      drupal_not_found();
    }
  }

  public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {
    $record = ms_events_get_ticket_by_id($form['#ms_id']);

    // Delete the record
    db_delete('ms_events_tickets')
      ->condition('id', $record->id)
      ->execute();

    drupal_set_message(t('Ticket Deleted'));
    $form_state->set(['redirect'], 'admin/ms_events_tickets');
  }

}
