<?php

/**
 * @file
 * Contains \Drupal\ms_events\Form\MsEventsDeleteTicketTypeConfirm.
 */

namespace Drupal\ms_events\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Render\Element;

class MsEventsDeleteTicketTypeConfirm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'ms_events_delete_ticket_type_confirm';
  }

  public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state, $type = NULL) {
    if ($record = ms_events_get_ticket_type($type)) {
      $form['#ms_id'] = $record->type;
      return confirm_form($form, t('Are you sure you want to delete this Ticket Type?'), 'admin/moneysuite/ms_events/ticket_types', t('This action cannot be undone.'), t('Delete'));
    }
    else {
      drupal_not_found();
    }
  }

  public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {
    $record = ms_events_get_ticket_type($form['#ms_id']);

    // Delete the record
    db_delete('ms_events_ticket_types')
      ->condition('type', $record->type)
      ->execute();

    drupal_set_message(t('Ticket type Deleted'));
    $form_state->set(['redirect'], 'admin/moneysuite/ms_events/ticket_types');
  }

}
